Package org.apache.commons.math3.linear

# Interface RealVectorChangingVisitor

public interface RealVectorChangingVisitor
This interface defines a visitor for the entries of a vector. Visitors implementing this interface may alter the entries of the vector being visited.

Since:
  3.1

## Method Summary

Modifier and Type
Method
Description
`double`
`end()`
End visiting a vector.
`void`
`start(int dimension, int start, int end)`
Start visiting a vector.
`double`
`visit(int index, double value)`
Visit one entry of the vector.

## Method Details

### start

void start(int dimension, int start, int end)
Start visiting a vector. This method is called once, before any entry of the vector is visited.

Parameters:
  `dimension` - the size of the vector
  `start` - the index of the first entry to be visited
  `end` - the index of the last entry to be visited (inclusive)

### visit

double visit(int index, double value)
Visit one entry of the vector.

Parameters:
  `index` - the index of the entry being visited
  `value` - the value of the entry being visited
Returns:
  the new value of the entry being visited

### end

double end()
End visiting a vector. This method is called once, after all entries of the vector have been visited.

Returns:
  the value returned by `RealVector.walkInDefaultOrder(RealVectorChangingVisitor)`, `RealVector.walkInDefaultOrder(RealVectorChangingVisitor, int, int)`, `RealVector.walkInOptimizedOrder(RealVectorChangingVisitor)` or `RealVector.walkInOptimizedOrder(RealVectorChangingVisitor, int, int)`